-- Asteroid Spotter Plugin
-- Visit http://web-adventures.org:3000/ for more information
-- Maintained by SlashGordon / Dentek Collector XX-62 in game. For use by WANG guild members only.

dofile("http.lua")
dofile("json.lua")

-- comment out for plugin :-
--dofile("tcpsock.lua")  -- for lua binary testing only

local url = 'http://web-adventures.org:3000/api'

function SpotterAPI()
	local api = {}
	
	api.postAsteroid = function(sector_id, char_id, object_id, ore_string)
		local post_body = 
		urlopen(url..'/roid/add', 'POST',
			function (not_ok, header, data)
				-- do nothing , no response expected
		
			end
			,{sector_id=tostring(sector_id), char_id=tostring(char_id), object_id=tostring(object_id), ore_string=ore_string})
	end
	
	api.getAsteroidList = function(sector_id, char_id, sector_table)
		urlopen(url..'/roid/list/'..tostring(sector_id), 'GET',
			function (not_ok, header, data)
				-- Parse json and populate the sector table
				local doc = json_decode(data)
				
				if ((sector_id == doc.sector_id) and (doc.asteroids ~= nil)) then
					for i, roid in ipairs(doc.asteroids) do
						sector_table[roid.object_id] = roid.ores
					end
				end
			end
			)
	end

	api.findAsteroid = function(sector_id, char_id, query)
		urlopen(url..'/roid/find?query='..query..'&sector_id='..tostring(sector_id), 'GET',
			function (not_ok, header, data)
				-- Parse json and print results
				local doc = json_decode(data)
				
				if (doc.results ~= nil) then
					for i, s in ipairs(doc.results) do
						print(s)
					end
				end
			end
			)
	end
	
	
	return api
end


	