local socket = require("socket")


function TCPSocket()
	local tcp = {}
	
	tcp.SetReadHandler =  function(this, rhf)
		this.rf = rhf;
		--print("SetReadHandler: "..tostring(this.rf))
	end

	tcp.SetWriteHandler =  function(this, whf)
		this.wf = whf
		--print("SetWriteHandler: "..tostring(whf))
	end
	
	tcp.Connect = function(this, host, port)
		this.socket = socket.connect(host, port)
		this.wf(nil) 
		return 1, nil
	end
	
	tcp.Send = function(this, content)
		--print("Send: "..content)
		this.socket:send(content)
		this.response = this.socket:receive("*a")
		this.rf()
		this.socket:close()
		return content:len()
	end
	
	tcp.Recv = function(this, content)
		print(this.response)
		return this.response, 0
	end
	
	return tcp
end


function Timer()
	local timer = {}
	
	timer.SetTimeout =  function(this, val)
	end
	
	return timer
end

--[[

function TCPSocket:create()
	local tcp = {}
	setmetatable(tcp, TCPSocket)
	return tcp
end

Methods:

- success, error = sock:Connect(host, port): establish a TCP connection to host:port. Returns 1,nil if successful, nil,"error message" otherwise. This is a *non-blocking* connect, which means it always returns immediately, whether or not the connection succeeded. The write callback (described below) will be called when the connect completes (whether it succeeds or fails).

- success, error = sock:Listen(port): listen on TCP port. Newly established connections will trigger a connection event, which we will get to shortly.

- newconn = sock:Accept(): return new TCPSocket object for the established connection.

- sock:SetConnectHandler(fn): set a callback which occurs when someone connects to a socket that is Listen()ing. You must Accept to get the new connection. Not used for outgoing connections.

- sock:SetReadHandler(fn): callback when data is available for reading. Disables callback if fn is nil.

- sock:SetWriteHandler(fn): callback when output buffer space is available for writing, or when the connection completes. Disables callback if fn is nil.

- nsent = sock:Send(string): send string to socket. Socket is in non-blocking mode (otherwise your whole client would lock up trying to send long strings) so will not always send entire string. nsent is the number of bytes sent.

- msg, errcode = sock:Recv(): get all available data. If there is a socket error, msg will be nil and errcode will contain the standard errno error code.

- errmsg = sock:GetSocketError(): if there is an error flagged on the socket, return the error message string. This is slightly wonky under OS X and Linux because it uses getsockopt(SO_ERROR) which isn't quite the same as errno, where errors usually go. Mostly useful for getting the status of a Connect() after the resulting write callback.

- hostname = sock:GetPeerName(): return string containing the IP and port of the remote end of the socket.
]]--